--
-- Rcsid[] = "$Id: hldlogic.vhd,v 2.1 1993/10/06 01:04:36 alex Exp $";
--

entity hldlogic is
port(HLDA : out bit;
     CLK,HOLD,TRESET,T2,T4,THALT,VCC: in bit);
end;

architecture structure of hldlogic is

signal n0, n1, n2, L1, L2: bit;

begin
U0 : and_gate  generic map(1,1) port map(n0,HOLD,n1);
U1 : nand_gate generic map(1,1) port map(n1,T2,T4,THALT,n2);
U2 : DFF1 port map(L1,n0,CLK,VCC,TRESET);
U2a : inv_gate port map(L2,L1);
u3 : buf_gate generic map(2,2) port map(HLDA,L1);
u4 : buf_gate generic map(2,2) port map(n2,L2);
end structure;
