--
-- Rcsid[] = "$Id: mux2to1.vhd,v 2.1 1993/10/06 01:04:36 alex Exp $";
--

-- SEL = 0 -- selects D0
-- SEL = 1 -- selects D1

entity MUX2TO1 is

port (Z   : out bit;
      SEL : in bit;
      D0  : bit;
      D1  : in bit);
end MUX2TO1;

architecture STR_MUX2TO1 of MUX2TO1 is

signal    L2 ,L3 ,L5 ,L6 : bit ;

begin
G1 : OR_gate   generic map (1, 1, 0, 0, 0) port map (Z, L2, L3);
G2 : AND_gate  generic map (1, 1, 0, 0, 0) port map (L2, L5, D0);
G3 : AND_gate  generic map (1, 1, 0, 0, 0) port map (L3, L6, D1);
G5 : INV_gate  generic map (1, 1, 0, 0, 0) port map (L5, SEL);
G6 : BUF_gate  generic map (1, 1, 0, 0, 0) port map (L6, SEL);
end STR_MUX2TO1;
