--
-- Rcsid[] = "$Id: prioenco.vhd,v 2.1 1993/10/06 01:04:36 alex Exp $";
--

entity prioenco is
port(
   A : out bit_vector(2 downto 0);
   I0,I1,I2,I3,I4,EN : in bit
	);
end;

architecture structure of prioenco is

signal n0, n1, n2, n3, n4, n5, n6, n7, n8, n9: bit;
signal n13: bit;

begin
 U0 : inv_gate generic map(1,1) port map(n0,I1);
 U1 : inv_gate generic map(1,1) port map(n1,I2);
 U2 : inv_gate generic map(1,1) port map(n2,I3);
 U3 : and_gate generic map(1,1) port map(n3,I0,n2,I2);
 U4 : and_gate generic map(1,1) port map(n4,I0,I2,I4);
 U5 : and_gate generic map(1,1) port map(n5,I0,n0);
 U6 : and_gate generic map(1,1) port map(n6,I0,I1,n2);
 U7 : and_gate generic map(1,1) port map(n7,I0,I4,I1);
 U8 : and_gate generic map(1,1) port map(n8,I0,I1,n1);
 U9 : and_gate generic map(1,1) port map(n9,I0,I1,I2,I3);
 U10 : or_gate generic map(1,1) port map(A(0),n3,n4,n5,n13);
 U11 : or_gate generic map(1,1) port map(A(1),n6,n7,n8,n13);
 U12 : or_gate generic map(1,1) port map(A(2),n9,n13);
 U13 : and_gate generic map(1,1) port map(n13,I0,EN);
end structure;
